package java.util.stream;

import java.util.function.IntFunction;
import java.util.Spliterator;

abstract class PipelineHelper<P_OUT>
{
    PipelineHelper() {
    }
    
    abstract StreamShape getSourceShape();
    
    abstract int getStreamAndOpFlags();
    
    abstract <P_IN> long exactOutputSizeIfKnown(Spliterator<P_IN> p0);
    
    abstract <P_IN, S extends Sink<P_OUT>> S wrapAndCopyInto(S p0, Spliterator<P_IN> p1);
    
    abstract <P_IN> void copyInto(Sink<P_IN> p0, Spliterator<P_IN> p1);
    
    abstract <P_IN> void copyIntoWithCancel(Sink<P_IN> p0, Spliterator<P_IN> p1);
    
    abstract <P_IN> Sink<P_IN> wrapSink(Sink<P_OUT> p0);
    
    abstract <P_IN> Spliterator<P_OUT> wrapSpliterator(Spliterator<P_IN> p0);
    
    abstract Node.Builder<P_OUT> makeNodeBuilder(long p0, IntFunction<P_OUT[]> p1);
    
    abstract <P_IN> Node<P_OUT> evaluate(Spliterator<P_IN> p0, boolean p1, IntFunction<P_OUT[]> p2);
}
